// Code generated by github.com/atombender/go-jsonschema, DO NOT EDIT.

package iplookups

import "encoding/json"
import "fmt"
import "reflect"

// Schema for MaxMind GeoIP2 ip lookups enrichment
type A200 struct {
	// Enabled corresponds to the JSON schema field "enabled".
	Enabled bool `json:"enabled"`

	// Name corresponds to the JSON schema field "name".
	Name string `json:"name"`

	// Parameters corresponds to the JSON schema field "parameters".
	Parameters A200Parameters `json:"parameters"`

	// Vendor corresponds to the JSON schema field "vendor".
	Vendor string `json:"vendor"`
}

type A200Parameters struct {
	// ConnectionType corresponds to the JSON schema field "connectionType".
	ConnectionType *A200ParametersConnectionType `json:"connectionType,omitempty"`

	// Domain corresponds to the JSON schema field "domain".
	Domain *A200ParametersDomain `json:"domain,omitempty"`

	// Geo corresponds to the JSON schema field "geo".
	Geo *A200ParametersGeo `json:"geo,omitempty"`

	// Isp corresponds to the JSON schema field "isp".
	Isp *A200ParametersIsp `json:"isp,omitempty"`
}

type A200ParametersConnectionType struct {
	// Database corresponds to the JSON schema field "database".
	Database A200ParametersConnectionTypeDatabase `json:"database"`

	// Uri corresponds to the JSON schema field "uri".
	Uri string `json:"uri"`
}

type A200ParametersConnectionTypeDatabase string

const A200ParametersConnectionTypeDatabaseGeoIP2ConnectionTypeMmdb A200ParametersConnectionTypeDatabase = "GeoIP2-Connection-Type.mmdb"

var enumValues_A200ParametersConnectionTypeDatabase = []interface{}{
	"GeoIP2-Connection-Type.mmdb",
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A200ParametersConnectionTypeDatabase) UnmarshalJSON(b []byte) error {
	var v string
	if err := json.Unmarshal(b, &v); err != nil {
		return err
	}
	var ok bool
	for _, expected := range enumValues_A200ParametersConnectionTypeDatabase {
		if reflect.DeepEqual(v, expected) {
			ok = true
			break
		}
	}
	if !ok {
		return fmt.Errorf("invalid value (expected one of %#v): %#v", enumValues_A200ParametersConnectionTypeDatabase, v)
	}
	*j = A200ParametersConnectionTypeDatabase(v)
	return nil
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A200ParametersConnectionType) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if _, ok := raw["database"]; raw != nil && !ok {
		return fmt.Errorf("field database in A200ParametersConnectionType: required")
	}
	if _, ok := raw["uri"]; raw != nil && !ok {
		return fmt.Errorf("field uri in A200ParametersConnectionType: required")
	}
	type Plain A200ParametersConnectionType
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = A200ParametersConnectionType(plain)
	return nil
}

type A200ParametersDomain struct {
	// Database corresponds to the JSON schema field "database".
	Database A200ParametersDomainDatabase `json:"database"`

	// Uri corresponds to the JSON schema field "uri".
	Uri string `json:"uri"`
}

type A200ParametersDomainDatabase string

const A200ParametersDomainDatabaseGeoIP2DomainMmdb A200ParametersDomainDatabase = "GeoIP2-Domain.mmdb"

var enumValues_A200ParametersDomainDatabase = []interface{}{
	"GeoIP2-Domain.mmdb",
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A200ParametersDomainDatabase) UnmarshalJSON(b []byte) error {
	var v string
	if err := json.Unmarshal(b, &v); err != nil {
		return err
	}
	var ok bool
	for _, expected := range enumValues_A200ParametersDomainDatabase {
		if reflect.DeepEqual(v, expected) {
			ok = true
			break
		}
	}
	if !ok {
		return fmt.Errorf("invalid value (expected one of %#v): %#v", enumValues_A200ParametersDomainDatabase, v)
	}
	*j = A200ParametersDomainDatabase(v)
	return nil
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A200ParametersDomain) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if _, ok := raw["database"]; raw != nil && !ok {
		return fmt.Errorf("field database in A200ParametersDomain: required")
	}
	if _, ok := raw["uri"]; raw != nil && !ok {
		return fmt.Errorf("field uri in A200ParametersDomain: required")
	}
	type Plain A200ParametersDomain
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = A200ParametersDomain(plain)
	return nil
}

type A200ParametersGeo struct {
	// Database corresponds to the JSON schema field "database".
	Database A200ParametersGeoDatabase `json:"database"`

	// Uri corresponds to the JSON schema field "uri".
	Uri string `json:"uri"`
}

type A200ParametersGeoDatabase string

const A200ParametersGeoDatabaseGeoIP2CityMmdb A200ParametersGeoDatabase = "GeoIP2-City.mmdb"
const A200ParametersGeoDatabaseGeoLite2CityMmdb A200ParametersGeoDatabase = "GeoLite2-City.mmdb"

var enumValues_A200ParametersGeoDatabase = []interface{}{
	"GeoLite2-City.mmdb",
	"GeoIP2-City.mmdb",
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A200ParametersGeoDatabase) UnmarshalJSON(b []byte) error {
	var v string
	if err := json.Unmarshal(b, &v); err != nil {
		return err
	}
	var ok bool
	for _, expected := range enumValues_A200ParametersGeoDatabase {
		if reflect.DeepEqual(v, expected) {
			ok = true
			break
		}
	}
	if !ok {
		return fmt.Errorf("invalid value (expected one of %#v): %#v", enumValues_A200ParametersGeoDatabase, v)
	}
	*j = A200ParametersGeoDatabase(v)
	return nil
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A200ParametersGeo) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if _, ok := raw["database"]; raw != nil && !ok {
		return fmt.Errorf("field database in A200ParametersGeo: required")
	}
	if _, ok := raw["uri"]; raw != nil && !ok {
		return fmt.Errorf("field uri in A200ParametersGeo: required")
	}
	type Plain A200ParametersGeo
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = A200ParametersGeo(plain)
	return nil
}

type A200ParametersIsp struct {
	// Database corresponds to the JSON schema field "database".
	Database A200ParametersIspDatabase `json:"database"`

	// Uri corresponds to the JSON schema field "uri".
	Uri string `json:"uri"`
}

type A200ParametersIspDatabase string

const A200ParametersIspDatabaseGeoIP2ISPMmdb A200ParametersIspDatabase = "GeoIP2-ISP.mmdb"

var enumValues_A200ParametersIspDatabase = []interface{}{
	"GeoIP2-ISP.mmdb",
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A200ParametersIspDatabase) UnmarshalJSON(b []byte) error {
	var v string
	if err := json.Unmarshal(b, &v); err != nil {
		return err
	}
	var ok bool
	for _, expected := range enumValues_A200ParametersIspDatabase {
		if reflect.DeepEqual(v, expected) {
			ok = true
			break
		}
	}
	if !ok {
		return fmt.Errorf("invalid value (expected one of %#v): %#v", enumValues_A200ParametersIspDatabase, v)
	}
	*j = A200ParametersIspDatabase(v)
	return nil
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A200ParametersIsp) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if _, ok := raw["database"]; raw != nil && !ok {
		return fmt.Errorf("field database in A200ParametersIsp: required")
	}
	if _, ok := raw["uri"]; raw != nil && !ok {
		return fmt.Errorf("field uri in A200ParametersIsp: required")
	}
	type Plain A200ParametersIsp
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = A200ParametersIsp(plain)
	return nil
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A200) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if _, ok := raw["enabled"]; raw != nil && !ok {
		return fmt.Errorf("field enabled in A200: required")
	}
	if _, ok := raw["name"]; raw != nil && !ok {
		return fmt.Errorf("field name in A200: required")
	}
	if _, ok := raw["parameters"]; raw != nil && !ok {
		return fmt.Errorf("field parameters in A200: required")
	}
	if _, ok := raw["vendor"]; raw != nil && !ok {
		return fmt.Errorf("field vendor in A200: required")
	}
	type Plain A200
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	if len(plain.Name) > 256 {
		return fmt.Errorf("field %s length: must be <= %d", "name", 256)
	}
	if len(plain.Vendor) > 256 {
		return fmt.Errorf("field %s length: must be <= %d", "vendor", 256)
	}
	*j = A200(plain)
	return nil
}